/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse slice_parse
#define yylex   slice_lex
#define yyerror slice_error
#define yylval  slice_lval
#define yychar  slice_char
#define yydebug slice_debug
#define yynerrs slice_nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ICE_MODULE = 258,
     ICE_CLASS = 259,
     ICE_INTERFACE = 260,
     ICE_EXCEPTION = 261,
     ICE_STRUCT = 262,
     ICE_SEQUENCE = 263,
     ICE_DICTIONARY = 264,
     ICE_ENUM = 265,
     ICE_OUT = 266,
     ICE_EXTENDS = 267,
     ICE_IMPLEMENTS = 268,
     ICE_THROWS = 269,
     ICE_VOID = 270,
     ICE_BYTE = 271,
     ICE_BOOL = 272,
     ICE_SHORT = 273,
     ICE_INT = 274,
     ICE_LONG = 275,
     ICE_FLOAT = 276,
     ICE_DOUBLE = 277,
     ICE_STRING = 278,
     ICE_OBJECT = 279,
     ICE_LOCAL_OBJECT = 280,
     ICE_LOCAL = 281,
     ICE_CONST = 282,
     ICE_FALSE = 283,
     ICE_TRUE = 284,
     ICE_NONMUTATING = 285,
     ICE_IDEMPOTENT = 286,
     ICE_SCOPE_DELIMITER = 287,
     ICE_IDENTIFIER = 288,
     ICE_STRING_LITERAL = 289,
     ICE_INTEGER_LITERAL = 290,
     ICE_FLOATING_POINT_LITERAL = 291,
     ICE_IDENT_OP = 292,
     ICE_KEYWORD_OP = 293
   };
#endif
#define ICE_MODULE 258
#define ICE_CLASS 259
#define ICE_INTERFACE 260
#define ICE_EXCEPTION 261
#define ICE_STRUCT 262
#define ICE_SEQUENCE 263
#define ICE_DICTIONARY 264
#define ICE_ENUM 265
#define ICE_OUT 266
#define ICE_EXTENDS 267
#define ICE_IMPLEMENTS 268
#define ICE_THROWS 269
#define ICE_VOID 270
#define ICE_BYTE 271
#define ICE_BOOL 272
#define ICE_SHORT 273
#define ICE_INT 274
#define ICE_LONG 275
#define ICE_FLOAT 276
#define ICE_DOUBLE 277
#define ICE_STRING 278
#define ICE_OBJECT 279
#define ICE_LOCAL_OBJECT 280
#define ICE_LOCAL 281
#define ICE_CONST 282
#define ICE_FALSE 283
#define ICE_TRUE 284
#define ICE_NONMUTATING 285
#define ICE_IDEMPOTENT 286
#define ICE_SCOPE_DELIMITER 287
#define ICE_IDENTIFIER 288
#define ICE_STRING_LITERAL 289
#define ICE_INTEGER_LITERAL 290
#define ICE_FLOATING_POINT_LITERAL 291
#define ICE_IDENT_OP 292
#define ICE_KEYWORD_OP 293




/* Copy the first part of user declarations.  */
#line 1 "Grammar.y"


// **********************************************************************
//
// Copyright (c) 2003
// ZeroC, Inc.
// Billerica, MA, USA
//
// All Rights Reserved.
//
// Ice is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License version 2 as published by
// the Free Software Foundation.
//
// **********************************************************************

#include <Slice/GrammarUtil.h>
#include <IceUtil/UUID.h>

#ifdef _WIN32
// I get these warnings from some bison versions:
// warning C4102: 'yyoverflowlab' : unreferenced label
#   pragma warning( disable : 4102 )
// warning C4065: switch statement contains 'default' but no 'case' labels
#   pragma warning( disable : 4065 )
#endif

using namespace std;
using namespace Slice;

void
slice_error(const char* s)
{
    // yacc and recent versions of Bison use "syntax error" instead
    // of "parse error".

    if (strcmp(s, "parse error") == 0)
    {
	unit->error("syntax error");
    }
    else
    {
	unit->error(s);
    }
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 219 "Grammar.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  10
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   729

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  63
/* YYNRULES -- Number of rules. */
#define YYNRULES  178
/* YYNRULES -- Number of states. */
#define YYNSTATES  252

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   293

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    44,    48,     2,    45,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    41,
      46,    49,    47,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    39,     2,    40,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    42,     2,    43,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     9,    10,    15,    19,    22,    23,
      25,    27,    29,    31,    33,    35,    37,    39,    41,    43,
      45,    47,    49,    50,    57,    60,    63,    66,    67,    75,
      78,    79,    84,    88,    91,    92,    95,    97,   100,   103,
     106,   107,   114,   119,   123,   126,   127,   129,   132,   135,
     138,   139,   148,   151,   152,   155,   156,   161,   165,   168,
     169,   171,   174,   176,   178,   180,   183,   187,   191,   194,
     198,   202,   203,   209,   210,   216,   218,   220,   223,   226,
     229,   230,   238,   242,   244,   246,   249,   250,   255,   259,
     262,   263,   265,   269,   271,   273,   275,   282,   289,   298,
     307,   310,   313,   314,   321,   325,   327,   329,   331,   332,
     334,   335,   336,   339,   344,   348,   354,   357,   362,   365,
     366,   368,   371,   375,   377,   379,   381,   383,   385,   387,
     389,   391,   393,   396,   398,   400,   403,   406,   408,   412,
     414,   416,   417,   419,   421,   423,   425,   427,   429,   435,
     440,   442,   444,   446,   448,   450,   452,   454,   456,   458,
     460,   462,   464,   466,   468,   470,   472,   474,   476,   478,
     480,   482,   484,   486,   488,   490,   492,   494,   496
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      51,     0,    -1,    53,    -1,    39,   108,    40,    -1,    -1,
      52,    54,    41,    53,    -1,     1,    41,    53,    -1,    52,
      54,    -1,    -1,    55,    -1,    72,    -1,    73,    -1,    86,
      -1,    87,    -1,    58,    -1,    59,    -1,    66,    -1,    67,
      -1,    95,    -1,    96,    -1,    98,    -1,   111,    -1,    -1,
       3,    33,    56,    42,    53,    43,    -1,     6,    33,    -1,
       6,   112,    -1,   109,    57,    -1,    -1,   109,    57,    61,
      60,    42,    62,    43,    -1,    12,   105,    -1,    -1,    52,
      64,    41,    62,    -1,     1,    41,    62,    -1,    52,    64,
      -1,    -1,   106,    33,    -1,    78,    -1,     7,    33,    -1,
       7,   112,    -1,   109,    65,    -1,    -1,   109,    65,    68,
      42,    69,    43,    -1,    52,    70,    41,    69,    -1,     1,
      41,    69,    -1,    52,    70,    -1,    -1,    78,    -1,     4,
      33,    -1,     4,   112,    -1,   109,    71,    -1,    -1,   109,
      71,    75,    76,    74,    42,    77,    43,    -1,    12,   105,
      -1,    -1,    13,    89,    -1,    -1,    52,    84,    41,    77,
      -1,     1,    41,    77,    -1,    52,    84,    -1,    -1,    63,
      -1,   106,   112,    -1,   106,    -1,   106,    -1,    15,    -1,
      79,    37,    -1,    30,    79,    37,    -1,    31,    79,    37,
      -1,    79,    38,    -1,    30,    79,    38,    -1,    31,    79,
      38,    -1,    -1,    80,   103,    44,    82,   104,    -1,    -1,
      80,     1,    44,    83,   104,    -1,    78,    -1,    81,    -1,
       5,    33,    -1,     5,   112,    -1,   109,    85,    -1,    -1,
     109,    85,    90,    88,    42,    91,    43,    -1,   105,    45,
      89,    -1,   105,    -1,    24,    -1,    12,    89,    -1,    -1,
      52,    92,    41,    91,    -1,     1,    41,    91,    -1,    52,
      92,    -1,    -1,    81,    -1,    94,    45,    93,    -1,    94,
      -1,   105,    -1,   112,    -1,   109,     8,    46,   106,    47,
      33,    -1,   109,     8,    46,   106,    47,   112,    -1,   109,
       9,    46,   106,    45,   106,    47,    33,    -1,   109,     9,
      46,   106,    45,   106,    47,   112,    -1,    10,    33,    -1,
      10,   112,    -1,    -1,   109,    97,    99,    42,   100,    43,
      -1,   101,    45,   100,    -1,   101,    -1,    33,    -1,   112,
      -1,    -1,    11,    -1,    -1,    -1,   102,    63,    -1,   103,
      45,   102,    63,    -1,   102,   106,   112,    -1,   103,    45,
     102,   106,   112,    -1,   102,   106,    -1,   103,    45,   102,
     106,    -1,    14,    93,    -1,    -1,    33,    -1,    32,    33,
      -1,   105,    32,    33,    -1,    16,    -1,    17,    -1,    18,
      -1,    19,    -1,    20,    -1,    21,    -1,    22,    -1,    23,
      -1,    24,    -1,    24,    48,    -1,    25,    -1,   105,    -1,
     105,    48,    -1,    34,   107,    -1,    34,    -1,   107,    45,
     108,    -1,   107,    -1,    26,    -1,    -1,    35,    -1,    36,
      -1,   105,    -1,    34,    -1,    28,    -1,    29,    -1,    27,
     106,    33,    49,   110,    -1,    27,   106,    49,   110,    -1,
       3,    -1,     4,    -1,     5,    -1,     6,    -1,     7,    -1,
       8,    -1,     9,    -1,    10,    -1,    11,    -1,    12,    -1,
      13,    -1,    14,    -1,    15,    -1,    16,    -1,    17,    -1,
      18,    -1,    19,    -1,    20,    -1,    21,    -1,    22,    -1,
      23,    -1,    24,    -1,    25,    -1,    26,    -1,    27,    -1,
      28,    -1,    29,    -1,    30,    -1,    31,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   106,   106,   114,   119,   127,   136,   140,   145,   152,
     156,   160,   164,   168,   172,   176,   180,   184,   188,   192,
     196,   200,   210,   209,   232,   236,   247,   258,   257,   282,
     291,   299,   308,   311,   316,   323,   336,   342,   346,   357,
     368,   367,   401,   410,   413,   418,   425,   431,   435,   446,
     460,   459,   489,   524,   532,   537,   545,   554,   557,   562,
     569,   592,   614,   640,   641,   650,   661,   672,   683,   694,
     705,   722,   721,   737,   736,   756,   757,   763,   767,   778,
     793,   792,   817,   852,   887,   897,   902,   910,   919,   922,
     927,   934,   940,   947,   959,   971,   982,   990,  1004,  1013,
    1028,  1032,  1044,  1043,  1071,  1077,  1085,  1097,  1105,  1114,
    1121,  1132,  1134,  1147,  1160,  1172,  1184,  1195,  1211,  1216,
    1224,  1227,  1233,  1246,  1250,  1254,  1258,  1262,  1266,  1270,
    1274,  1278,  1282,  1286,  1290,  1309,  1350,  1356,  1364,  1371,
    1383,  1390,  1400,  1410,  1420,  1449,  1457,  1465,  1478,  1485,
    1497,  1500,  1503,  1506,  1509,  1512,  1515,  1518,  1521,  1524,
    1527,  1530,  1533,  1536,  1539,  1542,  1545,  1548,  1551,  1554,
    1557,  1560,  1563,  1566,  1569,  1572,  1575,  1578,  1581
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ICE_MODULE", "ICE_CLASS", "ICE_INTERFACE", 
  "ICE_EXCEPTION", "ICE_STRUCT", "ICE_SEQUENCE", "ICE_DICTIONARY", 
  "ICE_ENUM", "ICE_OUT", "ICE_EXTENDS", "ICE_IMPLEMENTS", "ICE_THROWS", 
  "ICE_VOID", "ICE_BYTE", "ICE_BOOL", "ICE_SHORT", "ICE_INT", "ICE_LONG", 
  "ICE_FLOAT", "ICE_DOUBLE", "ICE_STRING", "ICE_OBJECT", 
  "ICE_LOCAL_OBJECT", "ICE_LOCAL", "ICE_CONST", "ICE_FALSE", "ICE_TRUE", 
  "ICE_NONMUTATING", "ICE_IDEMPOTENT", "ICE_SCOPE_DELIMITER", 
  "ICE_IDENTIFIER", "ICE_STRING_LITERAL", "ICE_INTEGER_LITERAL", 
  "ICE_FLOATING_POINT_LITERAL", "ICE_IDENT_OP", "ICE_KEYWORD_OP", "'['", 
  "']'", "';'", "'{'", "'}'", "')'", "','", "'<'", "'>'", "'*'", "'='", 
  "$accept", "start", "meta_data", "definitions", "definition", 
  "module_def", "@1", "exception_id", "exception_decl", "exception_def", 
  "@2", "exception_extends", "exception_exports", "type_id", 
  "exception_export", "struct_id", "struct_decl", "struct_def", "@3", 
  "struct_exports", "struct_export", "class_id", "class_decl", 
  "class_def", "@4", "class_extends", "implements", "class_exports", 
  "data_member", "return_type", "operation_preamble", "operation", "@5", 
  "@6", "class_export", "interface_id", "interface_decl", "interface_def", 
  "@7", "interface_list", "interface_extends", "interface_exports", 
  "interface_export", "exception_list", "exception", "sequence_def", 
  "dictionary_def", "enum_id", "enum_def", "@8", "enumerator_list", 
  "enumerator", "out_qualifier", "parameters", "throws", "scoped_name", 
  "type", "string_literal", "string_list", "local_qualifier", 
  "const_initializer", "const_def", "keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    91,
      93,    59,   123,   125,    41,    44,    60,    62,    42,    61
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    50,    51,    52,    52,    53,    53,    53,    53,    54,
      54,    54,    54,    54,    54,    54,    54,    54,    54,    54,
      54,    54,    56,    55,    57,    57,    58,    60,    59,    61,
      61,    62,    62,    62,    62,    63,    64,    65,    65,    66,
      68,    67,    69,    69,    69,    69,    70,    71,    71,    72,
      74,    73,    75,    75,    76,    76,    77,    77,    77,    77,
      78,    78,    78,    79,    79,    80,    80,    80,    80,    80,
      80,    82,    81,    83,    81,    84,    84,    85,    85,    86,
      88,    87,    89,    89,    89,    90,    90,    91,    91,    91,
      91,    92,    93,    93,    94,    94,    95,    95,    96,    96,
      97,    97,    99,    98,   100,   100,   101,   101,   101,   102,
     102,   103,   103,   103,   103,   103,   103,   103,   104,   104,
     105,   105,   105,   106,   106,   106,   106,   106,   106,   106,
     106,   106,   106,   106,   106,   106,   107,   107,   108,   108,
     109,   109,   110,   110,   110,   110,   110,   110,   111,   111,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     3,     0,     4,     3,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     6,     2,     2,     2,     0,     7,     2,
       0,     4,     3,     2,     0,     2,     1,     2,     2,     2,
       0,     6,     4,     3,     2,     0,     1,     2,     2,     2,
       0,     8,     2,     0,     2,     0,     4,     3,     2,     0,
       1,     2,     1,     1,     1,     2,     3,     3,     2,     3,
       3,     0,     5,     0,     5,     1,     1,     2,     2,     2,
       0,     7,     3,     1,     1,     2,     0,     4,     3,     2,
       0,     1,     3,     1,     1,     1,     6,     6,     8,     8,
       2,     2,     0,     6,     3,     1,     1,     1,     0,     1,
       0,     0,     2,     4,     3,     5,     2,     4,     2,     0,
       1,     2,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     2,     2,     1,     3,     1,
       1,     0,     1,     1,     1,     1,     1,     1,     5,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     0,     0,   141,     2,     0,   137,   139,     0,
       1,     0,   140,     0,     7,     9,    14,    15,    16,    17,
      10,    11,    12,    13,    18,    19,    20,     0,    21,     6,
     136,     0,     3,    22,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   133,     0,   120,   134,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    26,    39,    49,    79,
     102,   138,     0,   132,   121,     0,   135,     0,     0,     5,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,    47,
      48,    77,    78,    24,    25,    37,    38,     0,     0,   100,
     101,     0,    27,     0,     0,    55,     0,    80,     0,     0,
     122,     0,   146,   147,   145,   142,   143,   144,   149,     0,
       0,    29,     0,     0,    52,     0,    50,    84,    85,    83,
       0,   108,     0,   148,     0,     0,     0,     0,     0,     0,
      54,     0,     0,     0,   106,     0,   105,   107,    23,    96,
      97,     0,     0,     0,     0,     0,    60,    44,    46,    62,
      41,     0,    82,     0,     0,     0,   103,   108,     0,     0,
      33,    36,    28,    43,     0,    35,    61,     0,     0,     0,
       0,    64,     0,     0,     0,     0,    91,    89,    63,    81,
     104,    98,    99,    32,     0,    42,     0,    75,    76,    58,
      62,    51,    88,     0,     0,    65,    68,     0,   109,     0,
       0,     0,    31,    57,     0,    66,    69,    67,    70,    73,
     112,   116,    71,   110,    87,    56,   119,   114,   119,     0,
       0,    74,    72,   113,   117,   118,    93,    94,    95,   115,
       0,    92
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     3,     4,     5,    14,    15,    62,    56,    16,    17,
     132,   112,   164,   166,   180,    57,    18,    19,   113,   149,
     167,    58,    20,    21,   151,   115,   136,   189,   168,   194,
     195,   196,   238,   236,   209,    59,    22,    23,   140,   138,
     117,   175,   197,   245,   246,    24,    25,    60,    26,   118,
     155,   156,   219,   220,   241,    46,   198,     8,     9,    27,
     128,    28,   157
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -195
static const short yypact[] =
{
     306,    26,    45,    35,    37,  -195,    11,    45,    38,    31,
    -195,    55,  -195,   122,    49,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,   319,  -195,  -195,
    -195,    45,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,    43,  -195,    59,  -195,    27,    29,    11,   410,
     441,   472,   503,    52,    53,   534,    -6,    60,    14,     1,
    -195,  -195,    62,  -195,  -195,    68,  -195,    56,   124,  -195,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,   122,   122,  -195,
    -195,    -2,  -195,    64,    -2,    94,    41,  -195,    76,   295,
    -195,   124,  -195,  -195,  -195,  -195,  -195,    87,  -195,    73,
      77,    87,    84,   147,    87,    41,  -195,  -195,  -195,    36,
      85,   565,    86,  -195,   596,   122,   254,    90,   122,    91,
    -195,   107,    41,   192,  -195,   108,    83,  -195,  -195,  -195,
    -195,   114,   132,   122,   131,   147,  -195,   135,  -195,   627,
    -195,   226,  -195,   137,   677,   138,  -195,   565,   658,   254,
     141,  -195,  -195,  -195,   147,  -195,  -195,   143,   677,   142,
     192,  -195,   696,   696,    -4,    92,  -195,   148,  -195,  -195,
    -195,  -195,  -195,  -195,   254,  -195,   226,  -195,  -195,   150,
     343,  -195,  -195,    32,    39,  -195,  -195,    89,  -195,   122,
      40,   192,  -195,  -195,   226,  -195,  -195,  -195,  -195,  -195,
    -195,   627,  -195,   177,  -195,  -195,   180,  -195,   180,   122,
     379,  -195,  -195,  -195,   627,  -195,   152,    87,  -195,  -195,
     379,  -195
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -195,  -195,  -124,     4,  -195,  -195,  -195,  -195,  -195,  -195,
    -195,  -195,  -155,  -194,  -195,  -195,  -195,  -195,  -195,  -142,
    -195,  -195,  -195,  -195,  -195,  -195,  -195,  -178,  -131,  -106,
    -195,     7,  -195,  -195,  -195,  -195,  -195,  -195,  -195,   -91,
    -195,  -182,  -195,   -52,  -195,  -195,  -195,  -195,  -195,  -195,
      22,  -195,   -33,  -195,   -37,   -63,   -13,   196,   173,  -195,
      97,  -195,   -48
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -112
static const short yytable[] =
{
      47,   100,   102,   104,   106,   127,   111,   110,   212,   148,
      29,    -8,     1,   116,    -4,    -4,    -4,    -4,    -4,    -4,
      -4,    -4,   163,   183,   203,   230,   114,   -53,   223,   174,
      44,    45,   181,   215,   216,    10,   -30,    -4,    -4,   234,
      11,   148,   205,   -86,   150,   243,   235,   188,   131,   222,
       2,   134,    69,   139,    -8,   163,   -53,   207,   127,    65,
     148,   172,    67,    12,    13,   137,   174,     6,    65,   225,
     226,    32,   139,    44,    45,    66,   227,   228,    68,     7,
     163,   152,   188,    31,   232,   233,   213,   214,    33,   139,
      48,    63,    64,   217,   129,   130,   160,   174,   107,   108,
     188,   120,   -40,   218,   119,   121,   133,   135,  -110,  -110,
    -110,  -110,  -110,  -110,  -110,  -110,  -110,  -110,   141,    65,
     144,   186,   145,   142,  -110,  -110,   146,   153,   177,   158,
     202,   165,   161,   229,   170,   169,  -111,  -111,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,   147,   171,
     169,   176,   122,   123,    44,    45,    44,    45,   124,   125,
     126,   178,   186,    -4,    -4,    -4,    -4,    -4,    -4,    -4,
      -4,    -4,    -4,   179,   182,   210,   184,   247,   190,    -4,
      -4,   199,   204,   237,   206,   211,     2,   247,   218,   221,
     -45,   224,   248,   173,   240,   208,   249,   250,   251,   200,
     239,   242,   248,    30,    61,     0,   231,    -4,    -4,    -4,
      -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,   143,     0,
       0,     0,    -4,    -4,    -4,    -4,   244,   187,     0,     0,
       0,     2,     0,     0,     0,   -90,     0,     0,     0,     0,
       0,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,
      -4,    -4,     0,     0,     0,   162,    -4,    -4,    -4,    -4,
       0,     0,     0,     0,     0,     2,     0,     0,     0,   -59,
      -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,    -4,
       0,     0,     0,     0,     0,     0,    -4,    -4,     0,     0,
       0,     0,     0,     2,     0,     0,     1,   -34,    -4,    -4,
      -4,    -4,    -4,    -4,    -4,    -4,    -8,     1,     0,    -4,
      -4,    -4,    -4,    -4,    -4,    -4,    -4,     0,     0,     0,
       0,    -4,    -4,    49,    50,    51,    52,    53,    54,    55,
       0,     0,    -4,    -4,     2,     0,     0,     0,    -8,     0,
       0,     0,     0,     0,     0,     2,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,     0,   185,     0,     0,     0,
     -63,   -63,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    44,    45,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,     0,    99,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,     0,   101,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,     0,   103,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,     0,   105,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,     0,   109,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,     0,   154,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,     0,   159,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,     0,
     185,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
       0,   201,   191,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,     0,     0,     0,     0,   192,   193,    44,
      45,   191,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,     0,     0,     0,    44,    45
};

static const short yycheck[] =
{
      13,    49,    50,    51,    52,    68,    12,    55,   190,   133,
       6,     0,     1,    12,     3,     4,     5,     6,     7,     8,
       9,    10,   146,   165,   179,   219,    12,    13,   206,   153,
      32,    33,   163,    37,    38,     0,    42,    26,    27,   221,
       3,   165,   184,    42,   135,   239,   224,   171,   111,   204,
      39,   114,    48,   116,    43,   179,    42,   188,   121,    32,
     184,   152,    33,    26,    27,    24,   190,    41,    32,    37,
      38,    40,   135,    32,    33,    48,    37,    38,    49,    34,
     204,    45,   206,    45,    44,    45,   192,   193,    33,   152,
      41,    48,    33,     1,   107,   108,   144,   221,    46,    46,
     224,    33,    42,    11,    42,    49,    42,    13,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    42,    32,
      47,   169,    45,   119,    32,    33,    42,    42,    45,    43,
     178,    41,   145,    44,    43,   148,    44,    45,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,     1,    42,
     163,    43,    28,    29,    32,    33,    32,    33,    34,    35,
      36,    47,   210,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    41,    43,   188,    41,   240,    41,    32,
      33,    43,    41,   231,    41,    43,    39,   250,    11,    41,
      43,    41,   240,     1,    14,   188,   244,    45,   250,   177,
     233,   238,   250,     7,    31,    -1,   219,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,   121,    -1,
      -1,    -1,    30,    31,    32,    33,   239,     1,    -1,    -1,
      -1,    39,    -1,    -1,    -1,    43,    -1,    -1,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,     1,    30,    31,    32,    33,
      -1,    -1,    -1,    -1,    -1,    39,    -1,    -1,    -1,    43,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    -1,    -1,
      -1,    -1,    -1,    39,    -1,    -1,     1,    43,     3,     4,
       5,     6,     7,     8,     9,    10,     0,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    26,    27,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    26,    27,    39,    -1,    -1,    -1,    43,    -1,
      -1,    -1,    -1,    -1,    -1,    39,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    33,    -1,    -1,    -1,
      37,    38,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    33,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    -1,    33,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    33,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    33,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    33,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    33,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    -1,    33,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    -1,
      33,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      -1,    33,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,    39,    51,    52,    53,    41,    34,   107,   108,
       0,     3,    26,    27,    54,    55,    58,    59,    66,    67,
      72,    73,    86,    87,    95,    96,    98,   109,   111,    53,
     107,    45,    40,    33,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    32,    33,   105,   106,    41,     4,
       5,     6,     7,     8,     9,    10,    57,    65,    71,    85,
      97,   108,    56,    48,    33,    32,    48,    33,    49,    53,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    33,
     112,    33,   112,    33,   112,    33,   112,    46,    46,    33,
     112,    12,    61,    68,    12,    75,    12,    90,    99,    42,
      33,    49,    28,    29,    34,    35,    36,   105,   110,   106,
     106,   105,    60,    42,   105,    13,    76,    24,    89,   105,
      88,    42,    53,   110,    47,    45,    42,     1,    52,    69,
      89,    74,    45,    42,    33,   100,   101,   112,    43,    33,
     112,   106,     1,    52,    62,    41,    63,    70,    78,   106,
      43,    42,    89,     1,    52,    91,    43,    45,    47,    41,
      64,    78,    43,    69,    41,    33,   112,     1,    52,    77,
      41,    15,    30,    31,    79,    80,    81,    92,   106,    43,
     100,    33,   112,    62,    41,    69,    41,    78,    81,    84,
     106,    43,    91,    79,    79,    37,    38,     1,    11,   102,
     103,    41,    62,    77,    41,    37,    38,    37,    38,    44,
      63,   106,    44,    45,    91,    77,    83,   112,    82,   102,
      14,   104,   104,    63,   106,    93,    94,   105,   112,   112,
      45,    93
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 107 "Grammar.y"
    {
;}
    break;

  case 3:
#line 115 "Grammar.y"
    {
    yyval = yyvsp[-1];
;}
    break;

  case 4:
#line 119 "Grammar.y"
    {
    yyval = new StringListTok;
;}
    break;

  case 5:
#line 128 "Grammar.y"
    {
    StringListTokPtr metaData = StringListTokPtr::dynamicCast(yyvsp[-3]);
    ContainedPtr contained = ContainedPtr::dynamicCast(yyvsp[-2]);
    if(contained && !metaData->v.empty())
    {
	contained->setMetaData(metaData->v);
    }
;}
    break;

  case 6:
#line 137 "Grammar.y"
    {
    yyerrok;
;}
    break;

  case 7:
#line 141 "Grammar.y"
    {
    unit->error("`;' missing after definition");
;}
    break;

  case 8:
#line 145 "Grammar.y"
    {
;}
    break;

  case 9:
#line 153 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ModulePtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 10:
#line 157 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ClassDeclPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 11:
#line 161 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ClassDefPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 12:
#line 165 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ClassDeclPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 13:
#line 169 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ClassDefPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 14:
#line 173 "Grammar.y"
    {
    assert(yyvsp[0] == 0);
;}
    break;

  case 15:
#line 177 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ExceptionPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 16:
#line 181 "Grammar.y"
    {
    assert(yyvsp[0] == 0);
;}
    break;

  case 17:
#line 185 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || StructPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 18:
#line 189 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || SequencePtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 19:
#line 193 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || DictionaryPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 20:
#line 197 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || EnumPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 21:
#line 201 "Grammar.y"
    {
    assert(yyvsp[0] == 0 || ConstPtr::dynamicCast(yyvsp[0]));
;}
    break;

  case 22:
#line 210 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    ModulePtr module = cont->createModule(ident->v);
    if(!module)
    {
	YYERROR; // Can't continue, jump to next yyerrok
    }
    cont->checkIntroduced(ident->v, module);
    unit->pushContainer(module);
    yyval = module;
;}
    break;

  case 23:
#line 223 "Grammar.y"
    {
    unit->popContainer();
    yyval = yyvsp[-3];
;}
    break;

  case 24:
#line 233 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 25:
#line 237 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as exception name");
    yyval = yyvsp[0];
;}
    break;

  case 26:
#line 248 "Grammar.y"
    {
    unit->error("exceptions cannot be forward declared");
    yyval = 0;
;}
    break;

  case 27:
#line 258 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-2]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[-1]);
    ExceptionPtr base = ExceptionPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    ExceptionPtr ex = cont->createException(ident->v, base, local->v);
    if(!ex)
    {
	YYERROR; // Can't continue, jump to next yyerrok
    }
    cont->checkIntroduced(ident->v, ex);
    unit->pushContainer(ex);
    yyval = ex;
;}
    break;

  case 28:
#line 273 "Grammar.y"
    {
    unit->popContainer();
    yyval = yyvsp[-3];
;}
    break;

  case 29:
#line 283 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    ContainedPtr contained = cont->lookupException(scoped->v);
    cont->checkIntroduced(scoped->v);
    yyval = contained;
;}
    break;

  case 30:
#line 291 "Grammar.y"
    {
    yyval = 0;
;}
    break;

  case 31:
#line 300 "Grammar.y"
    {
    StringListTokPtr metaData = StringListTokPtr::dynamicCast(yyvsp[-3]);
    ContainedPtr contained = ContainedPtr::dynamicCast(yyvsp[-2]);
    if(contained && !metaData->v.empty())
    {
	contained->setMetaData(metaData->v);
    }
;}
    break;

  case 32:
#line 309 "Grammar.y"
    {
;}
    break;

  case 33:
#line 312 "Grammar.y"
    {
    unit->error("`;' missing after definition");
;}
    break;

  case 34:
#line 316 "Grammar.y"
    {
;}
    break;

  case 35:
#line 324 "Grammar.y"
    {
    TypePtr type = TypePtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    TypeStringTokPtr typestring = new TypeStringTok;
    typestring->v = make_pair(type, ident->v);
    yyval = typestring;
;}
    break;

  case 37:
#line 343 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 38:
#line 347 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as struct name");
    yyval = yyvsp[0];
;}
    break;

  case 39:
#line 358 "Grammar.y"
    {
    unit->error("structs cannot be forward declared");
    yyval = 0;
;}
    break;

  case 40:
#line 368 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    StructPtr st = cont->createStruct(ident->v, local->v);
    if(!st)
    {
	YYERROR; // Can't continue, jump to next yyerrok
    }
    cont->checkIntroduced(ident->v, st);
    unit->pushContainer(st);
    yyval = st;
;}
    break;

  case 41:
#line 382 "Grammar.y"
    {
    unit->popContainer();
    yyval = yyvsp[-3];

    //
    // Empty structures are not allowed
    //
    StructPtr st = StructPtr::dynamicCast(yyval);
    assert(st);
    if(st->dataMembers().empty())
    {
    	unit->error("struct `" + st->name() + "' must have at least one member");
    }
;}
    break;

  case 42:
#line 402 "Grammar.y"
    {
    StringListTokPtr metaData = StringListTokPtr::dynamicCast(yyvsp[-3]);
    ContainedPtr contained = ContainedPtr::dynamicCast(yyvsp[-2]);
    if(contained && !metaData->v.empty())
    {
	contained->setMetaData(metaData->v);
    }
;}
    break;

  case 43:
#line 411 "Grammar.y"
    {
;}
    break;

  case 44:
#line 414 "Grammar.y"
    {
    unit->error("`;' missing after definition");
;}
    break;

  case 45:
#line 418 "Grammar.y"
    {
;}
    break;

  case 47:
#line 432 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 48:
#line 436 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as class name");
    yyval = yyvsp[0];
;}
    break;

  case 49:
#line 447 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    ClassDeclPtr cl = cont->createClassDecl(ident->v, false, local->v);
    yyval = cl;
;}
    break;

  case 50:
#line 460 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-3]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[-2]);
    ContainerPtr cont = unit->currentContainer();
    ClassDefPtr base = ClassDefPtr::dynamicCast(yyvsp[-1]);
    ClassListTokPtr bases = ClassListTokPtr::dynamicCast(yyvsp[0]);
    if(base)
    {
	bases->v.push_front(base);
    }
    ClassDefPtr cl = cont->createClassDef(ident->v, false, bases->v, local->v);
    if(!cl)
    {
	YYERROR; // Can't continue, jump to next yyerrok
    }
    cont->checkIntroduced(ident->v, cl);
    unit->pushContainer(cl);
    yyval = cl;
;}
    break;

  case 51:
#line 480 "Grammar.y"
    {
    unit->popContainer();
    yyval = yyvsp[-3];
;}
    break;

  case 52:
#line 490 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    TypeList types = cont->lookupType(scoped->v);
    yyval = 0;
    if(!types.empty())
    {
	ClassDeclPtr cl = ClassDeclPtr::dynamicCast(types.front());
	if(!cl)
	{
	    string msg = "`";
	    msg += scoped->v;
	    msg += "' is not a class";
	    unit->error(msg);
	}
	else
	{
	    ClassDefPtr def = cl->definition();
	    if(!def)
	    {
		string msg = "`";
		msg += scoped->v;
		msg += "' has been declared but not defined";
		unit->error(msg);
	    }
	    else
	    {
	    	cont->checkIntroduced(scoped->v);
		yyval = def;
	    }
	}
    }
;}
    break;

  case 53:
#line 524 "Grammar.y"
    {
    yyval = 0;
;}
    break;

  case 54:
#line 533 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 55:
#line 537 "Grammar.y"
    {
    yyval = new ClassListTok;
;}
    break;

  case 56:
#line 546 "Grammar.y"
    {
    StringListTokPtr metaData = StringListTokPtr::dynamicCast(yyvsp[-3]);
    ContainedPtr contained = ContainedPtr::dynamicCast(yyvsp[-2]);
    if(contained && !metaData->v.empty())
    {
	contained->setMetaData(metaData->v);
    }
;}
    break;

  case 57:
#line 555 "Grammar.y"
    {
;}
    break;

  case 58:
#line 558 "Grammar.y"
    {
    unit->error("`;' missing after definition");
;}
    break;

  case 59:
#line 562 "Grammar.y"
    {
;}
    break;

  case 60:
#line 570 "Grammar.y"
    {
    TypePtr type = TypeStringTokPtr::dynamicCast(yyvsp[0])->v.first;
    string name = TypeStringTokPtr::dynamicCast(yyvsp[0])->v.second;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    DataMemberPtr dm;
    if(cl)
    {
	dm = cl->createDataMember(name, type);
    }
    StructPtr st = StructPtr::dynamicCast(unit->currentContainer());
    if(st)
    {
	dm = st->createDataMember(name, type);
    }
    ExceptionPtr ex = ExceptionPtr::dynamicCast(unit->currentContainer());
    if(ex)
    {
	dm = ex->createDataMember(name, type);
    }
    unit->currentContainer()->checkIntroduced(name, dm);
    yyval = dm;
;}
    break;

  case 61:
#line 593 "Grammar.y"
    {
    TypePtr type = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    if(cl)
    {
	yyval = cl->createDataMember(name, type);
    }
    StructPtr st = StructPtr::dynamicCast(unit->currentContainer());
    if(st)
    {
	yyval = st->createDataMember(name, type);
    }
    ExceptionPtr ex = ExceptionPtr::dynamicCast(unit->currentContainer());
    if(ex)
    {
	yyval = ex->createDataMember(name, type);
    }
    assert(yyval);
    unit->error("keyword `" + name + "' cannot be used as data member name");
;}
    break;

  case 62:
#line 615 "Grammar.y"
    {
    TypePtr type = TypePtr::dynamicCast(yyvsp[0]);
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    if(cl)
    {
        yyval = cl->createDataMember(IceUtil::generateUUID(), type);
    }
    StructPtr st = StructPtr::dynamicCast(unit->currentContainer());
    if(st)
    {
	yyval = st->createDataMember(IceUtil::generateUUID(), type);
    }
    ExceptionPtr ex = ExceptionPtr::dynamicCast(unit->currentContainer());
    if(ex)
    {
	yyval = ex->createDataMember(IceUtil::generateUUID(), type);
    }
    assert(yyval);
    unit->error("missing data member name");
;}
    break;

  case 64:
#line 642 "Grammar.y"
    {
    yyval = 0;
;}
    break;

  case 65:
#line 651 "Grammar.y"
    {
    TypePtr returnType = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    assert(cl);
    OperationPtr op = cl->createOperation(name, returnType);
    cl->checkIntroduced(name, op);
    unit->pushContainer(op);
    yyval = op;
;}
    break;

  case 66:
#line 662 "Grammar.y"
    {
    TypePtr returnType = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    assert(cl);
    OperationPtr op = cl->createOperation(name, returnType, Operation::Nonmutating);
    cl->checkIntroduced(name, op);
    unit->pushContainer(op);
    yyval = op;
;}
    break;

  case 67:
#line 673 "Grammar.y"
    {
    TypePtr returnType = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    assert(cl);
    OperationPtr op = cl->createOperation(name, returnType, Operation::Idempotent);
    cl->checkIntroduced(name, op);
    unit->pushContainer(op);
    yyval = op;
;}
    break;

  case 68:
#line 684 "Grammar.y"
    {
    TypePtr returnType = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    assert(cl);
    OperationPtr op = cl->createOperation(name, returnType);
    unit->pushContainer(op);
    unit->error("keyword `" + name + "' cannot be used as operation name");
    yyval = op;
;}
    break;

  case 69:
#line 695 "Grammar.y"
    {
    TypePtr returnType = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    assert(cl);
    OperationPtr op = cl->createOperation(name, returnType, Operation::Nonmutating);
    unit->pushContainer(op);
    unit->error("keyword `" + name + "' cannot be used as operation name");
    yyval = op;
;}
    break;

  case 70:
#line 706 "Grammar.y"
    {
    TypePtr returnType = TypePtr::dynamicCast(yyvsp[-1]);
    string name = StringTokPtr::dynamicCast(yyvsp[0])->v;
    ClassDefPtr cl = ClassDefPtr::dynamicCast(unit->currentContainer());
    assert(cl);
    OperationPtr op = cl->createOperation(name, returnType, Operation::Idempotent);
    unit->pushContainer(op);
    unit->error("keyword `" + name + "' cannot be used as operation name");
    yyval = op;
;}
    break;

  case 71:
#line 722 "Grammar.y"
    {
    unit->popContainer();
    yyval = yyvsp[-2];
;}
    break;

  case 72:
#line 727 "Grammar.y"
    {
    OperationPtr op = OperationPtr::dynamicCast(yyvsp[-1]);
    ExceptionListTokPtr el = ExceptionListTokPtr::dynamicCast(yyvsp[0]);
    assert(el);
    if(op)
    {
        op->setExceptionList(el->v);
    }
;}
    break;

  case 73:
#line 737 "Grammar.y"
    {
    unit->popContainer();
    yyerrok;
;}
    break;

  case 74:
#line 742 "Grammar.y"
    {
    OperationPtr op = OperationPtr::dynamicCast(yyvsp[-1]);
    ExceptionListTokPtr el = ExceptionListTokPtr::dynamicCast(yyvsp[0]);
    assert(el);
    if(op)
    {
        op->setExceptionList(el->v);
    }
;}
    break;

  case 77:
#line 764 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 78:
#line 768 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as interface name");
    yyval = yyvsp[0];
;}
    break;

  case 79:
#line 779 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    ClassDeclPtr cl = cont->createClassDecl(ident->v, true, local->v);
    cont->checkIntroduced(ident->v, cl);
    yyval = cl;
;}
    break;

  case 80:
#line 793 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-2]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[-1]);
    ContainerPtr cont = unit->currentContainer();
    ClassListTokPtr bases = ClassListTokPtr::dynamicCast(yyvsp[0]);
    ClassDefPtr cl = cont->createClassDef(ident->v, true, bases->v, local->v);
    if(!cl)
    {
	YYERROR; // Can't continue, jump to next yyerrok
    }
    cont->checkIntroduced(ident->v, cl);
    unit->pushContainer(cl);
    yyval = cl;
;}
    break;

  case 81:
#line 808 "Grammar.y"
    {
    unit->popContainer();
    yyval = yyvsp[-3];
;}
    break;

  case 82:
#line 818 "Grammar.y"
    {
    ClassListTokPtr intfs = ClassListTokPtr::dynamicCast(yyvsp[0]);
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[-2]);
    ContainerPtr cont = unit->currentContainer();
    TypeList types = cont->lookupType(scoped->v);
    if(!types.empty())
    {
	ClassDeclPtr cl = ClassDeclPtr::dynamicCast(types.front());
	if(!cl || !cl->isInterface())
	{
	    string msg = "`";
	    msg += scoped->v;
	    msg += "' is not an interface";
	    unit->error(msg);
	}
	else
	{
	    ClassDefPtr def = cl->definition();
	    if(!def)
	    {
		string msg = "`";
		msg += scoped->v;
		msg += "' has been declared but not defined";
		unit->error(msg);
	    }
	    else
	    {
	    	cont->checkIntroduced(scoped->v);
		intfs->v.push_front(def);
	    }
	}
    }
    yyval = intfs;
;}
    break;

  case 83:
#line 853 "Grammar.y"
    {
    ClassListTokPtr intfs = new ClassListTok;
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    TypeList types = cont->lookupType(scoped->v);
    if(!types.empty())
    {
	ClassDeclPtr cl = ClassDeclPtr::dynamicCast(types.front());
	if(!cl || !cl->isInterface())
	{
	    string msg = "`";
	    msg += scoped->v;
	    msg += "' is not an interface";
	    unit->error(msg);
	}
	else
	{
	    ClassDefPtr def = cl->definition();
	    if(!def)
	    {
		string msg = "`";
		msg += scoped->v;
		msg += "' has been declared but not defined";
		unit->error(msg);
	    }
	    else
	    {
	    	cont->checkIntroduced(scoped->v);
		intfs->v.push_front(def);
	    }
	}
    }
    yyval = intfs;
;}
    break;

  case 84:
#line 888 "Grammar.y"
    {
    unit->error("illegal inheritance from type Object");
    yyval = new ClassListTok;
;}
    break;

  case 85:
#line 898 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 86:
#line 902 "Grammar.y"
    {
    yyval = new ClassListTok;
;}
    break;

  case 87:
#line 911 "Grammar.y"
    {
    StringListTokPtr metaData = StringListTokPtr::dynamicCast(yyvsp[-3]);
    ContainedPtr contained = ContainedPtr::dynamicCast(yyvsp[-2]);
    if(contained && !metaData->v.empty())
    {
	contained->setMetaData(metaData->v);
    }
;}
    break;

  case 88:
#line 920 "Grammar.y"
    {
;}
    break;

  case 89:
#line 923 "Grammar.y"
    {
    unit->error("`;' missing after definition");
;}
    break;

  case 90:
#line 927 "Grammar.y"
    {
;}
    break;

  case 92:
#line 941 "Grammar.y"
    {
    ExceptionPtr exception = ExceptionPtr::dynamicCast(yyvsp[-2]);
    ExceptionListTokPtr exceptionList = ExceptionListTokPtr::dynamicCast(yyvsp[0]);
    exceptionList->v.push_front(exception);
    yyval = exceptionList;
;}
    break;

  case 93:
#line 948 "Grammar.y"
    {
    ExceptionPtr exception = ExceptionPtr::dynamicCast(yyvsp[0]);
    ExceptionListTokPtr exceptionList = new ExceptionListTok;
    exceptionList->v.push_front(exception);
    yyval = exceptionList;
;}
    break;

  case 94:
#line 960 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    ExceptionPtr exception = cont->lookupException(scoped->v);
    if(!exception)
    {
	exception = cont->createException(IceUtil::generateUUID(), 0, false);
    }
    cont->checkIntroduced(scoped->v, exception);
    yyval = exception;
;}
    break;

  case 95:
#line 972 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as exception name");
    yyval = unit->currentContainer()->createException(IceUtil::generateUUID(), 0, false);
;}
    break;

  case 96:
#line 983 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-5]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    TypePtr type = TypePtr::dynamicCast(yyvsp[-2]);
    ContainerPtr cont = unit->currentContainer();
    yyval = cont->createSequence(ident->v, type, local->v);
;}
    break;

  case 97:
#line 991 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-5]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    TypePtr type = TypePtr::dynamicCast(yyvsp[-2]);
    ContainerPtr cont = unit->currentContainer();
    yyval = cont->createSequence(ident->v, type, local->v);
    unit->error("keyword `" + ident->v + "' cannot be used as sequence name");
;}
    break;

  case 98:
#line 1005 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-7]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    TypePtr keyType = TypePtr::dynamicCast(yyvsp[-4]);
    TypePtr valueType = TypePtr::dynamicCast(yyvsp[-2]);
    ContainerPtr cont = unit->currentContainer();
    yyval = cont->createDictionary(ident->v, keyType, valueType, local->v);
;}
    break;

  case 99:
#line 1014 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-7]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    TypePtr keyType = TypePtr::dynamicCast(yyvsp[-4]);
    TypePtr valueType = TypePtr::dynamicCast(yyvsp[-2]);
    ContainerPtr cont = unit->currentContainer();
    yyval = cont->createDictionary(ident->v, keyType, valueType, local->v);
    unit->error("keyword `" + ident->v + "' cannot be used as dictionary name");
;}
    break;

  case 100:
#line 1029 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 101:
#line 1033 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as enumeration name");
    yyval = yyvsp[0];
;}
    break;

  case 102:
#line 1044 "Grammar.y"
    {
    BoolTokPtr local = BoolTokPtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    EnumPtr en = cont->createEnum(ident->v, local->v);
    cont->checkIntroduced(ident->v, en);
    yyval = en;
;}
    break;

  case 103:
#line 1053 "Grammar.y"
    {
    EnumPtr en = EnumPtr::dynamicCast(yyvsp[-3]);
    if(en)
    {
	EnumeratorListTokPtr enumerators = EnumeratorListTokPtr::dynamicCast(yyvsp[-1]);
	if(enumerators->v.empty())
	{
	    unit->error("enum `" + en->name() + "' must have at least one enumerator");
	}
	en->setEnumerators(enumerators->v);
    }
    yyval = yyvsp[-3];
;}
    break;

  case 104:
#line 1072 "Grammar.y"
    {
    EnumeratorListTokPtr ens = EnumeratorListTokPtr::dynamicCast(yyvsp[-2]);
    ens->v.splice(ens->v.end(), EnumeratorListTokPtr::dynamicCast(yyvsp[0])->v);
    yyval = ens;
;}
    break;

  case 105:
#line 1078 "Grammar.y"
    {
;}
    break;

  case 106:
#line 1086 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    EnumeratorListTokPtr ens = new EnumeratorListTok;
    ContainerPtr cont = unit->currentContainer();
    EnumeratorPtr en = cont->createEnumerator(ident->v);
    if(en)
    {
	ens->v.push_front(en);
    }
    yyval = ens;
;}
    break;

  case 107:
#line 1098 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("keyword `" + ident->v + "' cannot be used as enumerator");
    EnumeratorListTokPtr ens = new EnumeratorListTok;
    yyval = ens;
;}
    break;

  case 108:
#line 1105 "Grammar.y"
    {
    EnumeratorListTokPtr ens = new EnumeratorListTok;
    yyval = ens;
;}
    break;

  case 109:
#line 1115 "Grammar.y"
    {
    BoolTokPtr out = new BoolTok;
    out->v = true;
    yyval = out;
;}
    break;

  case 110:
#line 1121 "Grammar.y"
    {
    BoolTokPtr out = new BoolTok;
    out->v = false;
    yyval = out;
;}
    break;

  case 111:
#line 1132 "Grammar.y"
    {
;}
    break;

  case 112:
#line 1135 "Grammar.y"
    {
    BoolTokPtr isOutParam = BoolTokPtr::dynamicCast(yyvsp[-1]);
    TypeStringTokPtr tsp = TypeStringTokPtr::dynamicCast(yyvsp[0]);
    TypePtr type = tsp->v.first;
    string ident = tsp->v.second;
    OperationPtr op = OperationPtr::dynamicCast(unit->currentContainer());
    if(op)
    {
	ParamDeclPtr pd = op->createParamDecl(ident, type, isOutParam->v);
	unit->currentContainer()->checkIntroduced(ident, pd);
    }
;}
    break;

  case 113:
#line 1148 "Grammar.y"
    {
    BoolTokPtr isOutParam = BoolTokPtr::dynamicCast(yyvsp[-1]);
    TypeStringTokPtr tsp = TypeStringTokPtr::dynamicCast(yyvsp[0]);
    TypePtr type = tsp->v.first;
    string ident = tsp->v.second;
    OperationPtr op = OperationPtr::dynamicCast(unit->currentContainer());
    if(op)
    {
	ParamDeclPtr pd = op->createParamDecl(ident, type, isOutParam->v);
	unit->currentContainer()->checkIntroduced(ident, pd);
    }
;}
    break;

  case 114:
#line 1161 "Grammar.y"
    {
    BoolTokPtr isOutParam = BoolTokPtr::dynamicCast(yyvsp[-2]);
    TypePtr type = TypePtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    OperationPtr op = OperationPtr::dynamicCast(unit->currentContainer());
    if(op)
    {
	op->createParamDecl(ident->v, type, isOutParam->v);
	unit->error("keyword `" + ident->v + "' cannot be used as parameter name");
    }
;}
    break;

  case 115:
#line 1173 "Grammar.y"
    {
    BoolTokPtr isOutParam = BoolTokPtr::dynamicCast(yyvsp[-2]);
    TypePtr type = TypePtr::dynamicCast(yyvsp[-1]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    OperationPtr op = OperationPtr::dynamicCast(unit->currentContainer());
    if(op)
    {
	op->createParamDecl(ident->v, type, isOutParam->v);
	unit->error("keyword `" + ident->v + "' cannot be used as parameter name");
    }
;}
    break;

  case 116:
#line 1185 "Grammar.y"
    {
    BoolTokPtr isOutParam = BoolTokPtr::dynamicCast(yyvsp[-1]);
    TypePtr type = TypePtr::dynamicCast(yyvsp[0]);
    OperationPtr op = OperationPtr::dynamicCast(unit->currentContainer());
    if(op)
    {
	op->createParamDecl(IceUtil::generateUUID(), type, isOutParam->v);
	unit->error("missing parameter name");
    }
;}
    break;

  case 117:
#line 1196 "Grammar.y"
    {
    BoolTokPtr isOutParam = BoolTokPtr::dynamicCast(yyvsp[-1]);
    TypePtr type = TypePtr::dynamicCast(yyvsp[0]);
    OperationPtr op = OperationPtr::dynamicCast(unit->currentContainer());
    if(op)
    {
	op->createParamDecl(IceUtil::generateUUID(), type, isOutParam->v);
	unit->error("missing parameter name");
    }
;}
    break;

  case 118:
#line 1212 "Grammar.y"
    {
    yyval = yyvsp[0];
;}
    break;

  case 119:
#line 1216 "Grammar.y"
    {
    yyval = new ExceptionListTok;
;}
    break;

  case 120:
#line 1225 "Grammar.y"
    {
;}
    break;

  case 121:
#line 1228 "Grammar.y"
    {
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    ident->v = "::" + ident->v;
    yyval = ident;
;}
    break;

  case 122:
#line 1234 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[-2]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[0]);
    scoped->v += "::";
    scoped->v += ident->v;
    yyval = scoped;
;}
    break;

  case 123:
#line 1247 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindByte);
;}
    break;

  case 124:
#line 1251 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindBool);
;}
    break;

  case 125:
#line 1255 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindShort);
;}
    break;

  case 126:
#line 1259 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindInt);
;}
    break;

  case 127:
#line 1263 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindLong);
;}
    break;

  case 128:
#line 1267 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindFloat);
;}
    break;

  case 129:
#line 1271 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindDouble);
;}
    break;

  case 130:
#line 1275 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindString);
;}
    break;

  case 131:
#line 1279 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindObject);
;}
    break;

  case 132:
#line 1283 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindObjectProxy);
;}
    break;

  case 133:
#line 1287 "Grammar.y"
    {
    yyval = unit->builtin(Builtin::KindLocalObject);
;}
    break;

  case 134:
#line 1291 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[0]);
    ContainerPtr cont = unit->currentContainer();
    if(cont)
    {
	TypeList types = cont->lookupType(scoped->v);
	if(types.empty())
	{
	    YYERROR; // Can't continue, jump to next yyerrok
	}
	cont->checkIntroduced(scoped->v);
	yyval = types.front();
    }
    else
    {
        yyval = 0;
    }
;}
    break;

  case 135:
#line 1310 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[-1]);
    ContainerPtr cont = unit->currentContainer();
    if(cont)
    {
	TypeList types = cont->lookupType(scoped->v);
	if(types.empty())
	{
	    YYERROR; // Can't continue, jump to next yyerrok
	}
	for(TypeList::iterator p = types.begin(); p != types.end(); ++p)
	{
	    ClassDeclPtr cl = ClassDeclPtr::dynamicCast(*p);
	    if(!cl)
	    {
		string msg = "`";
		msg += scoped->v;
		msg += "' must be class or interface";
		unit->error(msg);
		YYERROR; // Can't continue, jump to next yyerrok
	    }
	    cont->checkIntroduced(scoped->v);
	    if(cl->isLocal())
	    {
		unit->error("cannot create proxy for " + cl->kindOf() + " `" + cl->name() + "'");
	    }
	    *p = new Proxy(cl);
	}
	yyval = types.front();
    }
    else
    {
        yyval = 0;
    }
;}
    break;

  case 136:
#line 1351 "Grammar.y"
    {
    StringTokPtr str1 = StringTokPtr::dynamicCast(yyvsp[-1]);
    StringTokPtr str2 = StringTokPtr::dynamicCast(yyvsp[0]);
    str1->v += str2->v;
;}
    break;

  case 137:
#line 1357 "Grammar.y"
    {
;}
    break;

  case 138:
#line 1365 "Grammar.y"
    {
    StringTokPtr str = StringTokPtr::dynamicCast(yyvsp[-2]);
    StringListTokPtr stringList = StringListTokPtr::dynamicCast(yyvsp[0]);
    stringList->v.push_back(str->v);
    yyval = stringList;
;}
    break;

  case 139:
#line 1372 "Grammar.y"
    {
    StringTokPtr str = StringTokPtr::dynamicCast(yyvsp[0]);
    StringListTokPtr stringList = new StringListTok;
    stringList->v.push_back(str->v);
    yyval = stringList;
;}
    break;

  case 140:
#line 1384 "Grammar.y"
    {
    BoolTokPtr local = new BoolTok;
    local->v = true;
    yyval = local;
;}
    break;

  case 141:
#line 1390 "Grammar.y"
    {
    BoolTokPtr local = new BoolTok;
    local->v = false;
    yyval = local;
;}
    break;

  case 142:
#line 1401 "Grammar.y"
    {
    BuiltinPtr type = unit->builtin(Builtin::KindLong);
    IntegerTokPtr intVal = IntegerTokPtr::dynamicCast(yyvsp[0]);
    ostringstream sstr;
    sstr << intVal->v;
    SyntaxTreeBaseStringTokPtr basestring = new SyntaxTreeBaseStringTok;
    basestring->v = pair<SyntaxTreeBasePtr,string>(type, sstr.str());
    yyval = basestring;
;}
    break;

  case 143:
#line 1411 "Grammar.y"
    {
    BuiltinPtr type = unit->builtin(Builtin::KindDouble);
    FloatingTokPtr floatVal = FloatingTokPtr::dynamicCast(yyvsp[0]);
    ostringstream sstr;
    sstr << floatVal->v;
    SyntaxTreeBaseStringTokPtr basestring = new SyntaxTreeBaseStringTok;
    basestring->v = pair<SyntaxTreeBasePtr,string>(type, sstr.str());
    yyval = basestring;
;}
    break;

  case 144:
#line 1421 "Grammar.y"
    {
    StringTokPtr scoped = StringTokPtr::dynamicCast(yyvsp[0]);
    SyntaxTreeBaseStringTokPtr basestring = new SyntaxTreeBaseStringTok;
    ContainedList cl = unit->currentContainer()->lookupContained(scoped->v);
    if(cl.empty())
    {
    	basestring->v = pair<SyntaxTreeBasePtr,string>(TypePtr(0), scoped->v);
    }
    else
    {
	EnumeratorPtr enumerator = EnumeratorPtr::dynamicCast(cl.front());
	if(!enumerator)
	{
	    string msg = "illegal initializer: `" + scoped->v + "' is a";
	    static const string vowels = "aeiou";
	    string kindOf = cl.front()->kindOf();
	    if(vowels.find_first_of(kindOf[0]) != string::npos)
	    {
	    	msg += "n";
	    }
	    msg += " " + kindOf;
	    unit->error(msg);
	}
	unit->currentContainer()->checkIntroduced(scoped->v, enumerator);
	basestring->v = pair<SyntaxTreeBasePtr,string>(enumerator, scoped->v);
    }
    yyval = basestring;
;}
    break;

  case 145:
#line 1450 "Grammar.y"
    {
    BuiltinPtr type = unit->builtin(Builtin::KindString);
    StringTokPtr literal = StringTokPtr::dynamicCast(yyvsp[0]);
    SyntaxTreeBaseStringTokPtr basestring = new SyntaxTreeBaseStringTok;
    basestring->v = pair<SyntaxTreeBasePtr,string>(type, literal->v);
    yyval = basestring;
;}
    break;

  case 146:
#line 1458 "Grammar.y"
    {
    BuiltinPtr type = unit->builtin(Builtin::KindBool);
    StringTokPtr literal = StringTokPtr::dynamicCast(yyvsp[0]);
    SyntaxTreeBaseStringTokPtr basestring = new SyntaxTreeBaseStringTok;
    basestring->v = pair<SyntaxTreeBasePtr,string>(type, literal->v);
    yyval = basestring;
;}
    break;

  case 147:
#line 1466 "Grammar.y"
    {
    BuiltinPtr type = unit->builtin(Builtin::KindBool);
    StringTokPtr literal = StringTokPtr::dynamicCast(yyvsp[0]);
    SyntaxTreeBaseStringTokPtr basestring = new SyntaxTreeBaseStringTok;
    basestring->v = pair<SyntaxTreeBasePtr,string>(type, literal->v);
    yyval = basestring;
;}
    break;

  case 148:
#line 1479 "Grammar.y"
    {
    TypePtr const_type = TypePtr::dynamicCast(yyvsp[-3]);
    StringTokPtr ident = StringTokPtr::dynamicCast(yyvsp[-2]);
    SyntaxTreeBaseStringTokPtr value = SyntaxTreeBaseStringTokPtr::dynamicCast(yyvsp[0]);
    yyval = unit->currentContainer()->createConst(ident->v, const_type, value->v.first, value->v.second);
;}
    break;

  case 149:
#line 1486 "Grammar.y"
    {
    TypePtr const_type = TypePtr::dynamicCast(yyvsp[-2]);
    SyntaxTreeBaseStringTokPtr value = SyntaxTreeBaseStringTokPtr::dynamicCast(yyvsp[0]);
    unit->error("missing constant name");
    yyval = unit->currentContainer()->createConst(IceUtil::generateUUID(), const_type, value->v.first, value->v.second);
;}
    break;

  case 150:
#line 1498 "Grammar.y"
    {
;}
    break;

  case 151:
#line 1501 "Grammar.y"
    {
;}
    break;

  case 152:
#line 1504 "Grammar.y"
    {
;}
    break;

  case 153:
#line 1507 "Grammar.y"
    {
;}
    break;

  case 154:
#line 1510 "Grammar.y"
    {
;}
    break;

  case 155:
#line 1513 "Grammar.y"
    {
;}
    break;

  case 156:
#line 1516 "Grammar.y"
    {
;}
    break;

  case 157:
#line 1519 "Grammar.y"
    {
;}
    break;

  case 158:
#line 1522 "Grammar.y"
    {
;}
    break;

  case 159:
#line 1525 "Grammar.y"
    {
;}
    break;

  case 160:
#line 1528 "Grammar.y"
    {
;}
    break;

  case 161:
#line 1531 "Grammar.y"
    {
;}
    break;

  case 162:
#line 1534 "Grammar.y"
    {
;}
    break;

  case 163:
#line 1537 "Grammar.y"
    {
;}
    break;

  case 164:
#line 1540 "Grammar.y"
    {
;}
    break;

  case 165:
#line 1543 "Grammar.y"
    {
;}
    break;

  case 166:
#line 1546 "Grammar.y"
    {
;}
    break;

  case 167:
#line 1549 "Grammar.y"
    {
;}
    break;

  case 168:
#line 1552 "Grammar.y"
    {
;}
    break;

  case 169:
#line 1555 "Grammar.y"
    {
;}
    break;

  case 170:
#line 1558 "Grammar.y"
    {
;}
    break;

  case 171:
#line 1561 "Grammar.y"
    {
;}
    break;

  case 172:
#line 1564 "Grammar.y"
    {
;}
    break;

  case 173:
#line 1567 "Grammar.y"
    {
;}
    break;

  case 174:
#line 1570 "Grammar.y"
    {
;}
    break;

  case 175:
#line 1573 "Grammar.y"
    {
;}
    break;

  case 176:
#line 1576 "Grammar.y"
    {
;}
    break;

  case 177:
#line 1579 "Grammar.y"
    {
;}
    break;

  case 178:
#line 1582 "Grammar.y"
    {
;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 3177 "Grammar.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1586 "Grammar.y"


